#ifndef CADNA_EIGEN_
#define CADNA_EIGEN_

#include <cadna.h>
#include <Eigen/Core>


namespace Eigen
{
  template <> struct NumTraits <double_st >:NumTraits < double >
  {
    typedef double_st Real;
    typedef double_st NonInteger;
    typedef double_st Nested;
    enum
    {
      IsComplex = 0,
      IsInteger = 0,
      IsSigned = 1,
      RequireInitialization = 1,
      ReadCost = 1,
      AddCost = 3,
      MulCost = 3
    };
  };
}
namespace adtl
{
  inline const double_st & conj (const double_st & x)
  {
    return x;
  }
  inline const double_st & real (const double_st & x)
  {
    return x;
  }
  inline double_st imag (const double_st &)
  {
    return 0.;
  }
  inline double_st abs (const double_st & x)
  {
    return fabs (x);
  }
  inline double_st abs2 (const double_st & x)
  {
    return x * x;
  }
}


namespace Eigen
{
  template <> struct NumTraits <float_st >:NumTraits < float >
  {
    typedef float_st Real;
    typedef float_st NonInteger;
    typedef float_st Nested;
    enum
    {
      IsComplex = 0,
      IsInteger = 0,
      IsSigned = 1,
      RequireInitialization = 1,
      ReadCost = 1,
      AddCost = 3,
      MulCost = 3
    };
  };
}
namespace adtl
{
  inline const float_st & conj (const float_st & x)
  {
    return x;
  }
  inline const float_st & real (const float_st & x)
  {
    return x;
  }
  inline float_st imag (const float_st &)
  {
    return 0.;
  }
  inline float_st abs (const float_st & x)
  {
    return fabs (x);
  }
  inline float_st abs2 (const float_st & x)
  {
    return x * x;
  }
}
#endif
